-- PackData.e V1.01 (C) 2004 Peter Blue / Digital Data Research

include machine.e
include get.e
include file.e

global constant PackDataVersion = 1

global function pdLoadFile(sequence fn)
	integer	h,s,x
	object	raw
	
	raw = {}
	h = open(fn,"rb")
	if h > 1 then
    x = seek(h,-1)
    s = where(h)
		x = seek(h,0)
		raw = get_bytes(h,s)
	end if
	
	return raw
end function

global procedure pdSaveFile(sequence fn,sequence raw)
	integer	h

	h = open(fn,"wb")
	if h > 0 then
		puts(h,raw)
	end if
end procedure


-- Pack multiple filename and data into one stream
global function PackFiles(sequence filenames)
	sequence	pak,fn,hdr
	integer		cnt,ptr

	cnt = length(filenames)
	hdr = {PackDataVersion,0,0,0} -- Header
	pak =  hdr & int_to_bytes(cnt) -- Hdr & Count
	ptr = length(pak) + 1
	pak &= repeat(0,(cnt + 1) * 4) -- Count * Pointers + one
	for i = 1 to cnt do
		pak[ptr..ptr + 3] = int_to_bytes(length(pak)+1)
		fn = filenames[i]
		pak &= fn & 0 & pdLoadFile(fn)
		ptr += 4
	end for
	pak[ptr..ptr + 3] = int_to_bytes(length(pak)+1)

	return pak
end function

global procedure UnpackFiles(sequence pak)
	sequence	tmp,hdr,lst,fn,raw
	integer		cnt,ptr,pt2,len,byt
	
	hdr = pak[1..4]
	cnt = bytes_to_int(pak[5..8])
	ptr = 9
	lst = repeat(0,cnt + 1)
	for i = 1 to cnt + 1 do -- Get pointer list
		lst[i] = bytes_to_int(pak[ptr..ptr + 3])
		ptr += 4
	end for
	for i = 1 to cnt do
		ptr = lst[i]
		pt2 = lst[i + 1]
		tmp = pak[ptr..pt2 - 1]
		len = length(tmp)
		fn = {}
		for j = 1 to len do -- Scan for ASCIIZ filename
			byt = tmp[j]
			if byt > 0 then
				fn &= byt
			else -- byte = 0
				raw = tmp[j + 1..len]
				exit
			end if
		end for
		pdSaveFile(fn,raw)
	end for
end procedure
